# ExactPredicates.jl

→ [Documentation](https://lairez.github.io/ExactPredicates.jl/)

This package provides fast and robust predicates for Euclidean geometry. It is
implemented as a code generator that transform any homogeneous polynomial into
an algorithm that rigorously determines its sign on any given input points.

### Installation

```julia
]add ExactPredicates
```

## Features

* Planar predicates: `orient` (left or right of a line), `incircle` (inside or
  outside a circle), `closest` (closer to this or that point), `meet` (intersection of line segments), etc.
* Spatial predicates: `orient` (above or below a plane), `insphere` (inside or
  outside a ball), `closest` (closer to this or that point), etc.
* Simplistic API, points are just `Tuple{Float64,Float64}` or `Tuple{Float64,Float64,Float64}`
* Accepts anything convertible to `Tuple`
* Extensible
* MIT license


### Robust

Robust means that the code:

- raises an exception on `NaN` and `Inf` arguments;
- gives a correct answer on all other inputs with `Float64` coordinates, no matter what (overflow, underflow, etc.);
- in particular, no restriction on the coordinate range.


#### Why robustness matters?

When the input data is approximate it looks absurd to insist on exact
computation. To determine if a point is inside or outside a circle, one may need
more precision than the data really convey. So what is the point?

Robust computation is important because it guarantees *soundness* with respect
to some combinatorial properties of the predicates, on which many algorithms
rely. For example
> `orient(a, b, c) == orient(b, c, a) == orient(c, a, b)`,

this
is a very basic geometric observation, but a floating computation may fail to
see this.


> “Inexact versions of these tests *[orient and incircle]* are vulnerable to roundoff error, and the wrong
> answers they produce can cause geometric algorithms to hang, crash, or produce
> incorrect output.”
>
> —Jonathan Shewchuk, *Robust Adaptive Floating-point Geometric Predicates*

### Fast

The reference point is the cost of the pure floating point evaluation, without any certification.
To evaluate the performance, one need to distinguish several scenarios.

#### The quick path

For normal input (for example random input), the floating point computation is
correct. The only overhead is the computation of the error bound. Expect a 2×
slowdown with respect to the reference. On complicated predicates, like
`insphere`, the floating point computation dominates and the slowdown is only
1.3×.

The emphasis in the package is to make the quick path as fast as possible.

#### The slow path

If the error estimation fails to certify the floating point computation, the
code falls back to interval arithmetic, using [IntervalArithmetic.jl](https://github.com/JuliaIntervals/IntervalArithmetic.jl). It will work especially well if the input points have small integer coordinates.
Expect a 50× slowdown.

In this scenario, adaptive methods, like the one famously implemented by [Shewchuk](https://www.cs.cmu.edu/~quake/robust.html), may be more performant.

#### The worst path

When the input points are maximally degenerate, the code will resort to exact arithmetic using `Rational{BigInt}`.
The computation will always succeed, but expect a 50-100× slowdown.


## Usage

### Basic usage 

The type for representing points is `NTuple{N, Float64}`, where `N` is 2 or 3. Very concretely, that is `Tuple{Float64,Float64}` or `Tuple{Float64,Float64,Float64}`.

```julia
p, q, r, a = (1.0, 3.0), (1.5, 10.0), (-87.0, 1e64), (1e-100, 3.0)

incircle(p, q, r, a)
# -> 1
```

### Working with other types of points

All the predicates will work with a type `T`, if one of the function `Tuple(::T)` or
`coord(::T)` is defined and outputs a `NTuple{N, Float64}` that contains the coordinates the
coordinates. Naturally, the computation is only robust if the conversion is robust too.
Here is a typical use.

```julia
using ExactPredicates
struct Point
    x :: Float64
    y :: Float64
end

Tuple(p :: Point) = (p.x, p.y)
incircle(Point(0.0, 0.0), Point(1.0, 0.0), Point(0.0, 1.0), Point(.5, .5))
```

A nice type to represent points in the plane is `Complex{Float64}`.
It is not desirable to redefine `Tuple(::Complex)`, so we overload `coord` instead.

```julia
coord(p :: Float64) = (p, 0.0)
coord(p :: Complex) = reim(p)
incircle(0.0, 1.0, complex(0.0, 1.0), complex(.5, .5))
```

Another interesting type for points is `SVector` from [StaticArrays](https://github.com/JuliaArrays/StaticArrays.jl).
`Tuple` is already defined for this type, so we can use them readily.

```julia
using StaticArrays
incircle(SVector(0.0, 0.0), SVector(1.0, 0.0), SVector(0.0, 1.0), SVector(.5, .5))
```

In all the examples above, the conversion has no overhead.

## Extensibility

The code generator turns any piece of code that evaluates a homogeneous polynomial
into a robust piece of code that evaluates the sign of the same polynomial.
It only needs hint to group variables into homogeneous groups.

For example, the discriminant of a degree 2 polynomial ``a x^2 + bx + c`` is ``b^2 - 4ac``, which is a homogeneous polynomial in ``a``, ``b`` and ``c``.
With ExactPredicates, you can write

```julia
using ExactPredicates
using ExactPredicates.Codegen

@genpredicate function discriminant(a, b, c)
    Codegen.group!(a, b, c)
    b*b - 4*a*c
end
```

It will define a function `discriminant(a :: Float64, b :: Float64, c :: Float64)` that returns 1, –1 or 0 depending on the sign of the determinant.


## How it works

This package implements the method used by CGAL and described in:

* Olivier Devillers, Sylvain Pion. “Efficient Exact Geometric Predicates for Delaunay Triangulations”. RR-4351, INRIA. 2002. [⟨inria-00072237⟩](https://hal.inria.fr/inria-00072237)
* Guillaume Melquiond, Sylvain Pion. “Formally Certified Floating-Point Filters For Homogeneous Geometric Predicates”. RAIRO, EDP Sciences, 2007, 41, pp. 57-69. [⟨10.1051/ita:2007005⟩](https://dx.doi.org/10.1051/ita:2007005) [⟨inria-00071232v2⟩](https://hal.inria.fr/inria-00071232)
* Andreas Meyer, Sylvain Pion. “FPG: A code generator for fast and certified geometric predicates”. Real Numbers and Computers, Jun 2008, Santiago de Compostela, Spain. pp.47-60. [⟨inria-00344297⟩](https://hal.inria.fr/inria-00344297)

The implementation relies on Julia's facilities for code generation and
evaluates *a priori* the precision of the floating evaluation, relatively to the
magnitude of the input variables.

using Test

using StaticArrays
using ExactPredicates
using ExactPredicates.Codegen
import Base: complex

import ExactPredicates: incircle_dbg, orient_dbg

p2(x, y=0.0) = (float(x), float(y))
p3(x, y=0, z=0) = (float(x), float(y), float(z))

@testset "easy" begin
    @test incircle(p2(0), p2(1), p2(0,1), p2(1/2,1/2)) == 1
    @test incircle(p2(0), p2(1), p2(0,1), p2(1,1)) == 0
    @test orient(p2(0.0), p2(1.0), p2(0.0,1.0)) == 1
    @test orient(p3(1.0), p3(0.0,1.0), p3(0,0,1.0), p3(0.0)) == 1
    @test insphere(p3(1.0), p3(0.0,1.0), p3(0,0,1.0), p3(0.0), p3(.5,.5,.5)) == 1
    @test closest(p2(0), p2(1), p2(0,1)) == 1
    @test closest(p3(0), p3(1), p3(0,1)) == 1
end


@testset "easy, with retcode" begin
    @test incircle_dbg(p2(0), p2(1), p2(0,1), p2(1/2,1/2)) == (1, Codegen.fastfp_flt)
    @test incircle_dbg(p2(0), p2(1), p2(0,1), p2(1,1)) == (0, Codegen.interval_flt)
    @test orient_dbg(p2(0.0), p2(1.0), p2(0.0,1.0)) == (1, Codegen.fastfp_flt)
end



@testset "perturbations" begin
    a = p2(0.0)
    b = p2(1.0)
    c = p2(0.0, 1.0)

    @test incircle_dbg(a, b, c, a) == (0, Codegen.zerotest_flt)
    @test incircle_dbg(a, b, c, b) == (0, Codegen.interval_flt)
    @test incircle_dbg(a, b, c, c) == (0, Codegen.interval_flt)
    @test incircle_dbg(a, b, b, c) == (0, Codegen.interval_flt)
    @test incircle(a, b, c, p2(nextfloat(0.0))) == 1
    @test incircle(a, b, c, p2(prevfloat(0.0))) == -1

    a = p2(2.0)
    b = p2(1.0, 1.0)
    c = p2(1.0, - 1.0)

    @test incircle(a, b, c, p2(0.0)) == 0
    @test incircle(a, b, c, p2(nextfloat(0.0))) == 1
    @test incircle(a, b, c, p2(prevfloat(0.0))) == -1
end


@testset "exactly collinear" begin
    for i in 1:10
        rpts = rand(1:2^26, 4)
        pts = (rand(1:2^26) + rand(1:2^26)*im)*rpts
        fpts = convert(Vector{Complex{Float64}}, pts)
        @test incircle_dbg(reinterpret(NTuple{2, Float64}, fpts)...) == (0, Codegen.exact_flt)
    end
end


@testset "exactly collinear (small integers)" begin
    for i in 1:10
        rpts = rand(1:2^5, 4)
        pts = (rand(1:2^5) + rand(1:2^5)*im)*rpts
        fpts = convert(Vector{Complex{Float64}}, pts)
        res, flt = incircle_dbg(reinterpret(NTuple{2, Float64}, fpts)...)
        @test res == 0
        @test flt ∈ [Codegen.zerotest_flt, Codegen.interval_flt]
    end
end


@testset "orient consistency" begin
    for i in 1:10
        a,b,c = randn(ComplexF64)*randn(Float64, 3)
        @test orient(a, b, c) == orient(b, c, a) == orient(c, a, b)
    end
end


@testset "fast zero detection" begin
    a, b, c, d = [reim(p) for p in randn(ComplexF64, 4)]
    @test orient_dbg(a, b, b) == (0, Codegen.zerotest_flt)
    @test orient_dbg(a, b, a) == (0, Codegen.zerotest_flt)
end

@testset "incircle consistency" begin
    for i in 1:10
        a,b,c,d = randn(ComplexF64)*[exp(x*im) for x in randn(Float64, 4)] .+ randn(ComplexF64)
        @test incircle(a,b,c,d) == -incircle(b,c,d,a) == incircle(c,d,a,b) == -incircle(d,a,b,c) == incircle(b,a,d,c) ==
            -incircle(a,c,b,d)
    end
end

@testset "orient3 consistency" begin
    for i in 1:10
        u, v, w = randn(SVector{3, SVector{3, Float64}})
        a = randn()*u + randn()*v + randn()*w
        @test orient(u, v, w, a) == -orient(v, w, a, u) == orient(w, a, u, v) == -orient(a, u, v, w) == orient(v, u, a, w)
    end
end

@testset "underflow incircle" begin
    p = randn(SVector{4, SVector{2, Float64}})

    s = Set()
    while all(abs(c) > floatmin(Float64) for r in p for c in r)
        push!(s, incircle(p...))
        p /= 2
    end

    @test length(s) == 1
end


@testset "overflow incircle" begin
    p = randn(SVector{4, SVector{2, Float64}})

    s = Set()
    while all(isfinite(c) for r in p for c in r)
        push!(s, incircle(p...))
        p *= 2
    end

    @test length(s) == 1
end

@testset "closest point 2d" begin
    a, b, p = (-264.2397483183316, -147.68399381193498),
    (-264.23974834572186, -147.68399391802012),
    (-264.2397478247797, -147.68399318319462)

    @test closest(a, b, p) == 1

    a, b, p =  (-754.9415749355259, 315.57575309957866),
    (-754.9415751576867, 315.5757530485543),
    (-754.9415749822347, 315.5757530017328)

    @test closest(a, b, p) == 1
end


import ExactPredicates: coord
struct Point{T}
    x :: T
    y :: T
end
coord(p :: Point) = (p.x, p.y)

@testset "genericity" begin
    @test incircle(Point(0.0,0.0), Point(1.0,0.0), Point(0.0, 1.0), Point(.5, 0.0)) == 1
end


@testset "parallelorder" begin
    for _ in 1:10
        a, b, c, d = randn(ComplexF64, 4)
        @test orient(a, b, c) == parallelorder(a, b, a, c)
    end
end


@testset "meet" begin
    for _ in 1:10
        t = [exp(im*2*pi*a) for a in sort(rand(4))]
        @test meet(t[1], t[2], t[3], t[4]) == -1
        @test meet(t[1], t[3], t[2], t[4]) == 1
        @test meet(t[1], t[3], t[3], t[4]) == 0
        @test meet(t[1], t[3], t[3], t[1]) == 0
    end

    @test meet(p2(0), p2(1), p2(3), p2(4)) == -1
    @test meet(p2(0), p2(3), p2(1), p2(4)) == 0
    @test meet(p2(1), p2(4), p2(1), p2(2)) == 0

    a = (0.0, 0.0)
    b = (2.0, 2.0)
    c = (-3., -8.)
    d = (-1., -1.)
    @test meet(a, b, c, d) == -1
    @test meet(c, d, a, b) == -1


end


@testset "rotation" begin
    using Random

    Random.seed!(1);
    angles = 3*pi*2*rand(30)
    sort!(angles)
    pts = [exp(im*α) for α in angles]
    @test rotation(pts) == 3
end


@testset "intersectorder" begin
    a, b, pa, pb, qa, qb = (complex(0.0), complex(1.0),
                            complex(0.0, 3.0), complex(2.0, 1.0),
                            complex(0.0, 2.0), complex(2.0, 1.0))

    @test intersectorder(a, b, pa, pb, qa, qb) == -1
    @test intersectorder(a, b, pb, pa, qa, qb) == 1

    for _ in 1:10
        a, b, pa, pb, qa, qb = randn(ComplexF64, 6)
        @test intersectorder(a, b, pa, pb, qa, qb) == intersectorder(qa, qb, a, b, pa, pb)
    end
end


@testset "lengthcompare" begin
    a = (0.0, 0.0)
    b = (2.0, 2.0)
    c = (-3., -8.)
    d = (-1., -1.)
    @test lengthcompare(c, d, a, b) == 1
    @test lengthcompare(a, b, c, d) == -1
    @test lengthcompare(c, (c[1]+d[1], c[2]+d[2]), a, b) == -1
end

@testset "Aqua" begin
    using Aqua
    Aqua.test_all(ExactPredicates; ambiguities=false, project_extras=false)
    Aqua.test_ambiguities(ExactPredicates) # don't pick up Base and Core
end

@testset "Throwing for invalid precision" begin
    msg = ((x::X, y::Y) where {X, Y}) -> "Invalid precision used for input $((x, y))::Tuple{$X, $Y}. You can only use Float64 numbers in predicates."
    @test_throws Codegen.InvalidPrecisionError coord((1.0, 2.0f0))
    @test_throws msg(1.0, 2.0f0) coord((1.0, 2.0f0))
    @test_throws msg(1, Int32(2)) coord((1, Int32(2)))
    @test_throws msg(5.0f0, 7.0f0) coord((5.0f0, 7.0f0))
    @test_throws msg(5.0f0, 7.0) coord((5.0f0, 7.0))
    @test_throws msg(1, 5) orient((1, 5), (1, 9), (1, 7))
    @test_throws msg(Float16(2.0), Float16(5.0)) coord((Float16(2.0), Float16(5.0)))
    p, q, r = (1.0, 5.0), (1.0, 9.0), (1.0f0, 7.0f0)
    @test_throws msg(1.0f0, 7.0f0) orient(p, q, r)
    s = (9.0f0, 17.0f0)
    @test_throws msg(1.0f0, 7.0f0) incircle(p, q, r, s)
    p1, q1, r1, s1, a1 = [rand(SVector{2, Float32}) for _ in 1:5]
    pt2 = Point(1.0f0, 2.0f0)
    q2 = Point(5.7f0, 2.5f0)
    r2 = Point(1.9f0, 17.3f0)
    s2 = Point(9.0f0, 17.0f0)
    a2 = Point(1.0f0, 2.32f0)
    for (p,q,r,s,a) in ((p1,q1,r1,s1,a1),(pt2,q2,r2,s2,a2))
        _p = p isa Point ? coord(p) : p
        @test_throws msg(_p...) orient(p, q, r)
        @test_throws msg(_p...) meet(p, q, r, s)
        @test_throws msg(_p...) closest(p, q, r)
        @test_throws msg(_p...) insphere(p, q, r, s, a)
        @test_throws msg(_p...) rotation([p,q,r])
        @test_throws msg(_p...) lengthcompare(p, q, r, s)
        @test_throws msg(_p...) intersectorder(p, q, r, s, a, s)
        @test_throws msg(_p...) parallelorder(p, q, r, s)
        @test_throws msg(_p...) orient(p, q, r, s)
    end
end

# SPDX-License-Identifier: MIT
# Author: Pierre Lairez



@genpredicate function orient(u :: 2, v :: 2, w :: 2)
    u = u - w
    v = v - w

    group!(u...)
    group!(v...)

    ext(u, v)
end
@doc """

    orient(p :: 2, q :: 2, r :: 2) -> Int

* Return 1 if `r` is on the left of the oriented line defined by `p` and `q`.
* Return –1 if `r` is on the right.
* Return 0 if `r` is on the line or if `p == q`.

""" orient(::NTuple{2, Float64}, ::NTuple{2, Float64}, ::NTuple{2, Float64})


@genpredicate function incircle(p :: 2, q :: 2, r :: 2, a :: 2)

    qp = q - p
    rp = r - p
    ap = a - p
    aq = a - q
    rq = r - q

    group!(qp...)
    group!(ap...)
    group!(rp...)
    group!(rq..., aq...)

    ext(qp, ap)*inp(rp, rq) - ext(qp, rp)*inp(ap, aq)
end
@doc """
    incircle(a :: 2, b :: 2, c :: 2, p :: 2) -> Int


Assume that `a`, `b` and `c` define a counterclockwise triangle.

* Return 1 if `p` is strictly inside the circumcircle of this triangle.
* Return –1 if `p` is outside.
* Return 0 if `p` is on the circle.

If the triangle is oriented clockwise, the signs are reversed.
If `a`, `b` and `c` are collinear, this degenerate to an orientation test.

If two of the four arguments are equal, return 0.

""" incircle(::NTuple{2, Float64}, ::NTuple{2, Float64}, ::NTuple{2, Float64}, ::NTuple{2, Float64})



@genpredicate function closest(p :: 2, q :: 2, a :: 2)
    qp = q - p
    pa = p - a
    qa = q - a

    group!(qp...)
    group!(pa..., qa...)

    inp(qp, pa+qa)
end
@doc """
    closest(p :: 2, q :: 2, a :: 2) -> Int

* Return 1 if `a` is closer to `p` than to `q`.
* Return –1 if `a` is closer to `q` than to `p`.
* Return 0 is `a` is equally close to both.
""" closest(::NTuple{2, Float64}, ::NTuple{2, Float64}, ::NTuple{2, Float64})



"""
    sameside(p :: 2, a :: 2, b :: 2)

Assume that the three arguments are collinear, on some line L

* Return 1 if `a` and `b` are on the same side of `p` on L
* Return -1 if `a` and `b` are on different sides
* Return 0 if `a == p` or `b == p`.
"""
function sameside(p :: Tuple{Float64, Float64}, a :: Tuple{Float64, Float64}, b :: Tuple{Float64, Float64})
    if a < p && b < p || a > p && b > p
        return 1
    elseif a < p && b > p || a > p && b < p
        return -1
    else
        return 0
    end
end

function sameside(p, a, b)
    sameside(coord(p), coord(a), coord(b))
end

"""
    meet(p :: 2, q :: 2, a :: 2, b :: 2)

* Return 1 if the open line segments `(p, q)` and `(a, b)` meet in a single point.
* Return 0 if the the closed line segments `[p, q]` and `[a, b]` meet in one or several points.
* Return –1 otherwise.
"""
function meet(p, q, a, b)
    pqa = orient(p, q, a)
    pqb = orient(p, q, b)
    abp = orient(a, b, p)
    abq = orient(a, b, q)

    if opposite_signs(pqa, pqb) && opposite_signs(abp, abq)
        return 1
    elseif (pqa != 0 && pqa == pqb)  || (abq != 0  && abp == abq)
        return -1
    elseif pqa == 0 && pqb == 0
        # all four points are collinear
        if sameside(p, a, b) == 1 && sameside(q, a, b) == 1 && sameside(a, p, q) == 1 && sameside(b, p, q) == 1
            return -1
        else
            return 0
        end
    else
        return 0
    end
end


@genpredicate function parallelorder(a :: 2, b :: 2, p :: 2, q :: 2)
    δ = b - a
    qp = q - p

    group!(δ...)
    group!(qp...)
    ext(δ, qp)
end
@doc """
    parallelorder(a :: 2, b :: 2, p :: 2, q :: 2) -> Int

Consider the oriented line defined by `a` and `b`
and the parallel lines passing through `p` and `q` respectively, with the same orientation.

* return 1 if the line passing through `p` is left of the line passing through `q`.
* return -1 in the reverse situation.
* return 0 if `a` and `b` are equal or if the parallel lines passing through `p` and `q` are equal.

This is a robust version of to `orient(b-a, q-p, 0)`.
Note also that `orient(a, b, c) == parallelorder(a, b, a, c)`.
""" parallelorder(:: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64})




"""
    rotation(pts :: AbstractVector)

Gives the [rotation number](https://en.wikipedia.org/wiki/Winding_number#Turning_number) of the polygonal path defined by the elements of `pts`.
"""
function rotation(pts :: AbstractVector{T}) where T
    u = rand(SVector{2, Float64})
    origin = (0.0, 0.0)

    n = length(pts)
    @assert n >= 3

    pts = copy(pts)
    push!(pts, pts[1], pts[2])

    r = 0
    o1 = parallelorder(origin, u, pts[1], pts[2])
    for i in 1:n
        o2 = parallelorder(origin, u, pts[i+1], pts[i+2])
        if opposite_signs(o1, o2)
            ro = parallelorder(pts[i], pts[i+1], pts[i+1], pts[i+2])
            @assert ro != 0
            if ro > 0 && o1 < 0
                r += 1
            elseif ro < 0 && o1 > 0
                r -= 1
            end
        end
        o1 = o2
    end

    return r
end



@genpredicate function intersectorder(a :: 2, b :: 2, pa :: 2, pb :: 2, qa :: 2, qb :: 2)
    pp = pb - pa
    qq = qb - qa
    δ = b - a
    p0 = pa - a
    q0 = qa - a

    group!(pp...)
    group!(qq...)
    group!(δ...)
    group!(p0..., q0...)

    det(ext(p0, pp), ext(q0, qq),
        ext(δ, pp), ext(δ, qq))
end
@doc """
    intersectorder(a :: 2, b :: 2, pa :: 2, pb :: 2, qa :: 2, qb :: 2) -> Int

Consider the oriented line *L* defined by `a` and `b`, the line *P* defined by
`pa` and `pb` and the line *Q* defined by `qa` and `qb`.

Assumes that `parallelorder(a, b, pa, pb)` and `parallelorder(a, b, qa, qb)` have the same sign.
    Otherwise, the result has the opposite sign.

* return -1 if the intersection of *P* with *L* comes before the intersection of *Q* with *L*, following the orientation of *L*.
* return 1 in the reverse situation
* return 0 in case of equality or degeneracy.
""" intersectorder(:: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64})



@genpredicate function lengthcompare(a :: 2, b :: 2, c :: 2, d :: 2)
    group!(a..., b..., c..., d...)
    return inp(a - b, a - b) - inp(c - d, c - d)
end

@doc """
    lengthcompare(a :: 2, b :: 2, c :: 2, d :: 2) -> Int

* return -1 if the distance between `a` and `b` is smaller than the distance between `c` and `d`
* return 1 in the reverse situation
* return 0 in case the distance are equal
"""
lengthcompare(:: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64}, :: NTuple{2, Float64})

# SPDX-License-Identifier: MIT
# Author: Pierre Lairez


@genpredicate nogeneric function closest(p :: 3, q :: 3, a :: 3)
    qp = q - p
    pa = p - a
    qa = q - a

    Codegen.group!(qp...)
    Codegen.group!(pa..., qa...)

    inp(qp, pa+qa)
end
@doc """
    closest(p :: 3, q :: 3, a :: 3) -> Int

Return 1 if `a` is closer to `p` than to `q`.
Return –1 if `a` is closer to `q` than to `p`.
Return 0 is `a` is equally close to both.
""" closest(::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64})



@genpredicate function orient(p :: 3, q :: 3, r :: 3, a :: 3)
    pa = p - a
    qa = q - a
    ra = r - a

    Codegen.group!(pa...)
    Codegen.group!(qa...)
    Codegen.group!(ra...)

    det(pa..., qa..., ra...)
end
@doc """
    orient(p :: 3, q :: 3, r :: 3, a :: 3) -> Int

Consider the oriented plane on which the triangle `pqr` is positively oriented.

* Return 1 if `a` is below this plane.
* Return –1 if `a` is above this plane.
* Return 0 if `a` lies on this plane.

""" orient(::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64})



@genpredicate function insphere(p :: 3, q :: 3, r :: 3, s :: 3, a :: 3)
    p = p - a
    q = q - a
    r = r - a
    s = s - a

    Codegen.group!(p..., q..., r..., s...)

    det(p..., abs2(p), q..., abs2(q), r..., abs2(r), s..., abs2(s))
end
@doc """
    insphere(p :: 3, q :: 3, r :: 3, s :: 3, a :: 3)

* Return 1 if `a` is inside the circumscribed sphere defined by the four points `p`, `q`, `r` and `s`.
* Return –1 if `a` is outside.
* Return 0 is `a` lies on the sphere or if the four points are coplanar.

""" insphere(::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64},::NTuple{3, Float64})

# SPDX-License-Identifier: MIT
# Author: Pierre Lairez

module Codegen

using IntervalArithmetic
using StaticArrays

import Base: +, *, -, one, convert, promote_rule

export coord, @genpredicate

@enum FilterEnum fastfp_flt zerotest_flt accuratefp_flt interval_flt exact_flt naive_flt nothing_flt

struct InvalidPrecisionError{T} <: Exception
    x::T
end
function Base.showerror(io :: IO, e :: InvalidPrecisionError{T}) where {T}
    print(io, "Invalid precision used for input ", e.x, "::$T. You can only use Float64 numbers in predicates.")
end

@inline _coord(x :: NTuple{N,Float64}) where {N} = x
_coord(x :: Tuple) = throw(InvalidPrecisionError(x))
_coord(x) = coord(x) 

@inline coord(x) = _coord(Tuple(x))
@inline coord(x :: Complex) = _coord(reim(x))

function adddict(a, b)
    d = copy(a)
    for k in keys(b)
        if haskey(a, k)
            d[k] += b[k]
        else
            d[k] = b[k]
        end
    end
    return d
end

function mergedict(a, b)
    d = copy(a)
    for k in keys(b)
        if haskey(a, k)
            d[k] = union(d[k], b[k])
        else
            d[k] = b[k]
        end
    end
    return d
end

mutable struct Formula <: Number
    id :: Symbol
    head :: Symbol
    args :: Vector
    group :: Union{Nothing, Symbol}
end

function Formula(name :: Union{Expr, Symbol}, group = nothing)
    s = gensym()
    Formula(s, :sym, [name], group)
end

macro var(args...)
    vars = [Formula(v) for v in args]
    Expr(:block,
         [Expr(:(=), esc(args[i]), vars[i]) for i in 1:length(vars)]...)
end

macro point2(args...)
    vars = [SVector(Formula(:($v[1])), Formula(:($v[2]))) for v in args]
    Expr(:block,
         [Expr(:(=), esc(args[i]), vars[i]) for i in 1:length(vars)]...)
end

function +(f :: Formula, g :: Formula)
    Formula(gensym(), :+, [f, g], nothing)
end

function *(f :: Formula, g :: Formula)
    Formula(gensym(), :*, [f, g], nothing)
end

function -(f :: Formula, g :: Formula)
    Formula(gensym(), :-, [f, g], nothing)
end

function -(f :: Formula)
    Formula(gensym(), :-, [f], nothing)
end



function convert(::Type{Formula}, i :: T) where T <: Integer
    Formula(gensym(), :const, [i], nothing)
end

zero(::Type{Formula}) = convert(Formula, 0)

promote_rule(::Type{T}, ::Type{Formula}) where {T <: Integer} = Formula
promote_rule(::Type{Bool}, ::Type{Formula}) = Formula # method ambiguity


function group!(args...)
    @gensym g
    for f in args
        f.group = g
    end
end


function accumulator(f :: Formula)
    if f.head == :sym
        ret = (deg = Dict(), groups = Dict(), bound = Inf, error = 0.0)
    elseif f.head == :+ || (f.head == :- && length(f.args) == 2)
        af = accumulator(f.args[1])
        ag = accumulator(f.args[2])
        @assert af.deg == ag.deg

        bound = nextfloat(af.bound + ag.bound)
        error = nextfloat(nextfloat(af.error + ag.error) + eps(bound)/2)
        ret = (deg = af.deg, groups = mergedict(af.groups, ag.groups), bound = bound, error = error)
    elseif f.head == :*
        af = accumulator(f.args[1])
        ag = accumulator(f.args[2])
        bound = nextfloat(af.bound * ag.bound)
        error = nextfloat(nextfloat(nextfloat(af.error*ag.bound) + nextfloat(af.bound*ag.error)) + eps(bound)/2)
        ret = (deg = adddict(af.deg, ag.deg), groups = mergedict(af.groups, ag.groups), bound = bound, error = error)
    elseif f.head == :-
        ret = accumulator(f.args[1])
    elseif f.head == :const
        ret = (deg = Dict(), groups = Dict(), bound = abs(float(f.args[1])), error = 0.0)
    else
        throw(DomainError())
    end

    if !isnothing(f.group)
        @assert f.head == :sym || f.head == :- && f.args[1].head == f.args[2].head == :sym
        ret = (deg = Dict(f.group => 1), groups = Dict(f.group => Set([f.id])), bound = 1.0, error = eps(1.0)/2)
    end

    return ret
end


function evalcode(f :: Formula, conv = nothing)
    code = []
    stack = [f]
    syms = Set{Symbol}()

    while !isempty(stack)
        e = pop!(stack)

        if e.id ∈ syms
            continue
        end

        s = (e.id)

        if e.head == :sym
            if isnothing(conv)
                push!(code, Expr(:(=), s, e.args[1]))
            else
                push!(code, Expr(:(=), s, conv(e.args[1])))
            end
        elseif e.head == :const
            push!(code, code, Expr(:(=), s, e.args[1]))
        else
            if all(a.id ∈ syms for a in e.args)
                push!(code, Expr(:(=), s, Expr(:call, e.head, ((a.id) for a in e.args)...)))
            else
                push!(stack, e, e.args...)
                continue
            end
        end

        push!(syms, e.id)
    end

    return quote
        $(code...)
        $(f.id)
    end
end


function fastfilter(f :: Formula ; withretcode :: Bool = false)
    code = []

    @gensym res

    let
        fpcode = quote
            $res = $(evalcode(f))
        end
        push!(code, fpcode)
    end

    # Now code contains the computation of the formula, nothing more. We can
    # reliably determine the sign of the result if its absolute value is larger
    # than acc.error*scaling. The scaling depends on the homogeneity structure
    # of the formula.

    # The format of acc.groups is Dict(g1=>[a,b,c,...], g2=>[d,e,f,...], ...),
    # where a, b, c, ... are input gates (or difference or input gates, which
    # are considered as new input gates). The formula is expected to be
    # multihomogeneous w.r.t. to each group. The degree of homogeneity w.r.t to
    # the group g is acc.deg[g]. Therefore, the appropriate scaling is the
    # product of all λ[g]^acc.deg[g], where λ[g] is the maximum
    # absolute value of an input in group g.

    # The accurate way of determining if abs(res) >
    # acc.error*Π λ[g]^acc.deg[g] is to do the computation with fp numbers.
    # But we can check quickly a sufficient condition just with integer
    # arithmetic on the exponents.

    # There are two fundamental things to check: that no overflow occurred with computing res
    # and that no underflow occurs when computing acc.error*Π λ[g]^acc.deg[g].

    acc = accumulator(f)
    totdeg = UInt(sum(values(acc.deg)))

    @gensym signres

    let
        # we first try to determine if the absolute value of the result is
        # bigger than the maximal possible absolute error by looking only at the
        # exponents.

        emask = Base.exponent_mask(Float64)
        mantissabits = UInt(Base.Math.significand_bits(Float64))
        grouplogs = []
        for (idx, g) in acc.groups
            @gensym glog
            push!(grouplogs, glog)

            alllogs = [:(reinterpret(UInt64, $v) & $emask) for v in g]
            push!(code, :($glog = max($(alllogs...)) >> $mantissabits))
            # we could probably work without the shift, but it would make it
            # harder to think about overflows/underflows.

            if acc.deg[idx] != 1
                push!(code, :($glog *= $(acc.deg[idx])))
            end
        end

        errlog = ((reinterpret(UInt64, acc.error) & emask) >> mantissabits) -
            totdeg * ( Base.exponent_one(Float64) >> mantissabits ) + totdeg

        @gensym ε
        @gensym reslog
        @gensym rawres

        filter = quote
            $ε = $(Expr(:call, :+, errlog, grouplogs...))
            $rawres = reinterpret(UInt64, $res)
            $signres = Base.ifelse($rawres & $(Base.sign_mask(Float64)) == 0, 1, -1)
            $reslog = ($rawres & $emask) >> $mantissabits

            if $reslog != $(emask >> mantissabits) && # protect against Inf and Nan
                #$ε ≥ 0 &&       # protect against underflow in computation of ε
                $reslog > $ε    # main test
                # we should check that ε is not
                # negative. But since we are in unsigned arithmetic, ε < 0 means
                # actually that ε is big, so reslog > ε cannot hold.

                $(withretcode ? :(return ($signres, $fastfp_flt)) : :(return $signres))
            end
        end
        push!(code, filter)
    end


    let
        # Quick test is non conclusive. We check if there is a group in which
        # all the variables are zero, in which case the result is zero.

        filter = quote
            if $(Expr(:call, :|,
                      (Expr(:call, :&,
                            (Expr(:call, :(==), v, 0.0)
                             for v in g)...)
                       for g in values(acc.groups))...)
                 )

                $(withretcode ? :(return (0, $zerotest_flt)) : :(return 0))
            end
        end
        push!(code, filter)
    end


    let
        # We now go to the finer, more straight forward, test.

        groupabs = []
        for (idx, g) in acc.groups
            @gensym gabs
            push!(groupabs, gabs)
            allabs = [:(abs($v)) for v in g]
            push!(code, :($gabs = max($(allabs...))))

            if acc.deg[idx] != 1
                push!(code, :($gabs = $gabs^$(acc.deg[idx])))
            end
        end

        errabs =  acc.error * (1+eps(1.0))^totdeg

        @gensym ε

        filter = quote
            $ε = *($(groupabs...)) * $errabs
            if !issubnormal($ε) && $ε > 0 && isfinite($res) && abs($res) > $ε
                $(withretcode ? :(return ($signres, $accuratefp_flt)) : :(return $signres))
            end
        end
        push!(code, filter)
    end

    return quote
        $(code...)
    end

end


function ivfilter(f :: Formula ; withretcode :: Bool = false)

    @gensym ivres
    quote
        # We now resort to interval arithmetic It is an interesting filter when
        # the data is made of exactly representable integers.
        $ivres = $(evalcode(f,  s -> :( interval($s) )))
        if isstrictless($ivres, interval(0.0))
            $(withretcode ? :(return (-1, $interval_flt)) : :(return -1))
        elseif isstrictless(interval(0.0), $ivres)
            $(withretcode ? :(return (1, $interval_flt)) : :(return 1))
        elseif mag($ivres) == 0
            $(withretcode ? :(return (0, $interval_flt)) : :(return 0))
        end
    end

end

function exfilter(f :: Formula ; withretcode :: Bool = false)

    @gensym exrec
    quote
        # Exact arithmetic. Always conclusive.
        $exrec = $(evalcode(f, s -> :( Rational{BigInt}($s) )))
        $(withretcode ? :(return (Int(sign($exrec)), $exact_flt)) : :(return Int(sign($exrec))))
    end

end

function naivefilter(f :: Formula  ; withretcode :: Bool = false)
    @gensym fpres
    quote
        # Exact arithmetic. Always conclusive.
        $fpres = $(evalcode(f))
        if $fpres < 0
            $(withretcode ? :(return (-1, $naive_flt)) : :(return -1))
        elseif $fpres > 0
            $(withretcode ? :(return (1, $naive_flt)) : :(return 1))
        else
            $(withretcode ? :(return (0, $naive_flt)) : :(return 0))
        end
    end
end

"""

Generate sign predicate for a function that computes a polynomial in the
coordinates of the arguments.

"""
macro genpredicate(args...)
    if first(args) == :nogeneric
        defgeneric = false
        fun = args[2]
    else
        defgeneric = true
        fun = args[1]
    end

    sig = fun.args[1]
    args = sig.args[2:length(sig.args)]

    @assert fun.head == :function

    nargs = []
    tupleconv = []
    input = []
    for a in args
        if isa(a, Symbol)
            push!(input, Formula(a))
            push!(nargs, :($a :: Float64))
        elseif isa(a, Expr) && a.head == :(::)
            v, dim = a.args
            push!(input, SVector((Formula(:($v[$i])) for i in 1:dim)...))
            push!(nargs, :($v :: NTuple{$dim, Float64}))
            push!(tupleconv, :($v = _coord($v)))
        else
            throw(DomainError("Unknown argument $a"))
        end
    end

    base = string(sig.args[1])
    mainf = esc(Symbol(base))
    slowf = esc(Symbol(base, "_slow"))
    referencef = esc(Symbol(base, "_reference"))
    naivef = esc(Symbol(base, "_naive"))

    debug = s -> esc(Symbol(s.args[1], "_dbg"))

    nsig = (a for a in nargs)
    vars = (a.args[1] for a in nargs)

    # This is the fun part: we inject into the body of the function given in
    # argument the formal input. This gives an object of type Formula that
    # represents the polynomial.
    formula = Core.eval(__module__,
         Expr(:call,
              Expr(:->, Expr(:tuple, vars...), fun.args[2]),
              input...))

    if defgeneric
        genfun = quote
            function $(mainf)($(vars...))
                $(tupleconv...)
                return $(mainf)($(vars...))
            end
        end
    else
        genfun = quote end
    end


    quote
        function $(naivef)($(nsig...))
            $(naivefilter(formula))
        end

        function $(debug(naivef))($(nsig...))
            $(naivefilter(formula, withretcode=true))
        end

        function $(referencef)($(nsig...))
            $(exfilter(formula))
        end

        function $(debug(referencef))($(nsig...))
            $(exfilter(formula, withretcode=true))
        end

        function $(slowf)($(nsig...))
            $(ivfilter(formula))
            return $(referencef)($(vars...))
        end

        function $(debug(slowf))($(nsig...))
            $(ivfilter(formula, withretcode=true))
            return $(debug(referencef))($(vars...))
        end

        Core.@__doc__(@inline function $(mainf)($(nsig...))
            $(fastfilter(formula))
            return $(slowf)($(vars...))
        end)

        function $(debug(mainf))($(nsig...))
            $(fastfilter(formula, withretcode=true))
            return $(debug(slowf))($(vars...))
        end

        $(genfun)

    end




end




end

# SPDX-License-Identifier: MIT
# Author: Pierre Lairez

module ExactPredicates

export incircle, orient, closest, insphere, meet, sameside, rotation, parallelorder, intersectorder, lengthcompare

include("Codegen.jl")

using StaticArrays
using IntervalArithmetic

using .Codegen: group!, @genpredicate
import .Codegen: coord

export coord


# A few helper functions

const R2 = SVector{2}
const R3 = SVector{3}

ext(u :: R2, v :: R2) = u[1] * v[2] - u[2] * v[1]
inp(u :: R2, v :: R2) = u[1] * v[1] + u[2] * v[2]
inp(u :: R3, v :: R3) = u[1] * v[1] + u[2] * v[2] + u[3] * v[3]

det(a,b,c,d) = a*d-b*c
det(a,b,c,d,e,f,g,h,i) = a*det(e,f,h,i) - d*det(b,c,h,i) + g*det(b,c,e,f)

@inline function det(m1, m5, m9, m13, m2, m6, m10, m14, m3, m7, m11, m15, m4, m8, m12, m16)
    p34 = m11*m16 - m12*m15
    p23 = m10*m15 - m11*m14
    p12 = m9 *m14 - m10*m13
    p13 = m9 *m15 - m11*m13
    p14 = m9 *m16 - m12*m13
    p24 = m10*m16 - m12*m14
    return (
          m1*(m6*p34 - m7*p24 + m8*p23)
        - m2*(m5*p34 - m7*p14 + m8*p13)
        + m3*(m5*p24 - m6*p14 + m8*p12)
        - m4*(m5*p23 - m6*p13 + m7*p12)
    )
end

abs2(u :: SVector) = inp(u, u)


# if x and y are integer in {-1, 0, 1}, then xor(x,y)==-2 is equivalent to x*y == -1.
opposite_signs(x :: Int, y :: Int) = (xor(x, y) == -2)



include("plane.jl")
include("space.jl")


end

push!(LOAD_PATH, "../src/")

using Documenter, ExactPredicates

makedocs(
    sitename="ExactPredicates.jl",
    pages = ["index.md", "api.md"],
    repo = "https://github.com/lairez/ExactPredicates.jl/blob/master{path}#{line}"
)

deploydocs(
    repo = "github.com/lairez/ExactPredicates.jl.git",
    devbranch = "master",
    versions = ["stable" => "v^"]
)

# API

The pseudo type `:: 2` indicate `Tuple{Float64,Float64}` or any type `T` such
that `ExactPredicates.coord(::T)` or `Base.Tuple(::T)` outputs a
`Tuple{Float64,Float64}`. Similarly, `:: 3` indicates
`Tuple{Float64,Float64,Float64}` or any type convertible to it `coord` or
`Tuple`.

## Planar predicates

```@autodocs
Modules = [ExactPredicates]
Pages = ["plane.jl"]
```

## Spatial predicates


```@autodocs
Modules = [ExactPredicates]
Pages = ["space.jl"]
```
